/*
 * Version: @(#) 1.3 SSOA/ws/code/soa.sca.container.spi/src/com/ibm/wsspi/container/binding/ServiceProvider.java, WAS.soa.sca.container.spi, SCA101.SSOA, cf051018.03 09/08/10 01:52:35 [5/10/10 22:21:28]
 *
 * COMPONENT_NAME: <WAS.soa.sca.container.spi>
 *
 * IBM Confidential OCO Source Material
 * 5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N01, 5733-W61 (C) COPYRIGHT International Business Machines Corp. 2009
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 *
 *
 * HISTORY
 * CMVC Ref         Date      Who       Description
 * --------------- 	--------- --------- --------------------------------------------
 * F00CmnContainer  20090605  srashmi   Initial Implementation
 * F003438-14830    20090806  srashmi   Change createInvoker to pass generic type O 
 */

package com.ibm.wsspi.container.binding;



/**
 * Manages the runtime behavior of a Service through the SPI.
 * @ibm-spi
 */
public interface ServiceProvider <B extends Binding, I, O> {
    
	/**
     * start the provider
     *     
     */
    void start();

    /**
     * stop the provider
     *     
     */
    void stop();

    /**
     * Creates an invoker given an operation. Operation can be a WSDL operation or 
     * java Method
     * 
     * @return Invoker
     *     
     */
    I createInvoker(O operation);           
    
}
